LPARAM lcDBC
LOCAL lcPath,lcAlias,liCount,liIDT,liIDF,luValue,luValueO
LOCAL ARRAY xxa(1),xxb(1)
PRIVATE loDBC

CLEAR
#INCLUDE "dbc.h"

lcPath=SYS(16)
lcPath=IIF(RAT("\",lcPath)>0,LEFT(lcPath,RAT("\",lcPath)),lcPath)
SET PROCEDURE TO (lcPath+"dbc.prg")

lcAlias=SYS(2015)
lcDBC=IIF(EMPTY(lcDBC),HOME(2)+"\Tastrade\Data\tastrade.dbc",lcDBC)

loDBC=CREATEOBJECT("_DBC_Check") && _DBC


IF loDBC.OpenTable(lcDBC,lcAlias,"")#_DBC_ErrOK
   WAIT WIND "Can not open DBC file."
   RETURN
ENDIF


* Get all parts of database (inclusive of database)
liCount=loDBC.EnumObjects(lcAlias,_DBC_DataBase,"",@xxa)
=PrintObjects(liCount,@xxa)

* Get Stored Procedure
=loDBC.GetSP(lcAlias,_DBC_SP_TSource,@luValue)
?LEFT(luValue,100)+"..."
=loDBC.GetSP(lcAlias,_DBC_SP_TFXP,@luValue)
?LEFT(luValue,100)+"..."

* Set Stored Procedure
*!*	=DBC_SetSP(lcAlias,_DBC_SP_TSource,@luValue)
*!*	=DBC_SetSP(lcAlias,_DBC_SP_TFXP,@luValue)


* Get all tables
liCount=loDBC.EnumObjects(lcAlias,_DBC_Table,"",@xxa)
=PrintObjects(liCount,@xxa)

* Get all views
liCount=loDBC.EnumObjects(lcAlias,_DBC_View,"",@xxa)
=PrintObjects(liCount,@xxa)

* Get all Connections
liCount=loDBC.EnumObjects(lcAlias,_DBC_Connection,"",@xxa)
=PrintObjects(liCount,@xxa)


liIDT=loDBC.GetIDObject(lcAlias,_DBC_Table,"products")

* Get all Fields for table/view
liCount=loDBC.EnumObjects(lcAlias,_DBC_Field,liIDT,@xxa)
=PrintObjects(liCount,@xxa)

* Get all properties for Field
?"products."+xxa(1,2)
liCount=loDBC.EnumProperty(lcAlias,xxa(1,1),@xxb)
=PrintProperties(liCount,@xxb)

* xxa(1,1) - ID of Field
* xxb(2,1) - ID of Property, equal to _DBCID_Comment (in this case)

* Get property 
=loDBC.GetProperty(lcAlias,xxa(1,1),_DBCID_Comment,@luValueO)
?"Current value: products."+xxa(1,2)+"-"+loDBC.FormatProperty(_DBCID_Comment),luValueO

* Set property
=loDBC.SetProperty(lcAlias,xxa(1,1),_DBCID_Comment,"New comment"+SYS(2015))
=loDBC.GetProperty(lcAlias,xxa(1,1),_DBCID_Comment,@luValue)
?"New value: products."+xxa(1,2)+"-"+loDBC.FormatProperty(_DBCID_Comment),luValue

* Clear property
=loDBC.ClearProperty(lcAlias,xxa(1,1),_DBCID_Comment)
=loDBC.GetProperty(lcAlias,xxa(1,1),_DBCID_Comment,@luValue)
?"Droped: products."+xxa(1,2)+"-"+loDBC.FormatProperty(_DBCID_Comment),luValue

* Restore property
=loDBC.SetProperty(lcAlias,xxa(1,1),_DBCID_Comment,@luValueO)
=loDBC.GetProperty(lcAlias,xxa(1,1),_DBCID_Comment,@luValue)
?"Restored value: products."+xxa(1,2)+"-"+loDBC.FormatProperty(_DBCID_Comment),luValue

* Get all Relations for table/view
liCount=loDBC.EnumObjects(lcAlias,_DBC_Relation,liIDT,@xxa)
=PrintObjects(liCount,@xxa)

* Get RI Info for relation
=loDBC.RIInfo(lcAlias,xxa(1,1),@luValue)
?"products."+xxa(1,2),luValue


* Get all Indexes for table/view
liCount=loDBC.EnumObjects(lcAlias,_DBC_Index,liIDT,@xxa)
=PrintObjects(liCount,@xxa)

*****************************************************
* How to use connector for own properties
*****************************************************
#DEFINE MyProperty 1000 && user cutom property (string)
#DEFINE MyProperty2 1001 && user cutom property (any type)
#DEFINE _XXX_ValueType_XString 50000

loDBC.oConnector=CREATEOBJECT("_my_Connector")
* Set New property
=loDBC.SetProperty(lcAlias,liIDT,MyProperty,"Wow, I can write own property")
=loDBC.GetProperty(lcAlias,liIDT,MyProperty,@luValue)
?liIDT,MyProperty,luValue

liIDT=loDBC.GetIDObject(lcAlias,_DBC_Field,"products.product_id")
=loDBC.SetProperty(lcAlias,liIDT,MyProperty,"Wow, I can write own property")
=loDBC.GetProperty(lcAlias,liIDT,MyProperty,@luValue)
?liIDT,MyProperty,luValue

liIDT=loDBC.GetIDObject(lcAlias,_DBC_Field,"products.product_id")
?loDBC.SetProperty(lcAlias,liIDT,MyProperty2,"A") && OK
?loDBC.SetProperty(lcAlias,liIDT,MyProperty2,"G") && Failed

* Run checking method
*=loDBC.Check(lcAlias)


=loDBC.CloseTable(lcAlias)


***********************************************************************************

PROCEDURE PrintObjects(liCount,laArray)
LOCAL lii
?PADR("ID",11)+" "+"Name"
FOR lii=1 TO liCount
    ?STR(laArray(lii,1),11)+" "+laArray(lii,2)
NEXT
?


PROCEDURE PrintProperties(liCount,laArray)
LOCAL lii,lcType
?PADR("ID",11)+" "+PADR("Name",30)+" "+"Value"
FOR lii=1 TO liCount
    lcType=TYPE("laArray(lii,2)")
    ?STR(laArray(lii,1),11)+" "+PADR(loDBC.FormatProperty(laArray(lii,1)),30)+" "+;
      IIF(ISNULL(laArray(lii,2)),".NULL.",;
      IIF(lcType="N",STR(laArray(lii,2),17),;
      IIF(lcType="C",laArray(lii,2),;
      IIF(lcType="L",IIF(laArray(lii,2),".T.",".F."),"Unknown"))))
NEXT
?


DEFINE CLASS _my_Connector AS _DBC_Connector
   
   PROCEDURE FormatProperty(liIDProp) && Convert property ID to Name
      * liIDProp   - Property ID
      RETURN IIF(liIDProp=MyProperty,"My New Property",;
             IIF(liIDProp=MyProperty2,"My New Property2","")) 
   ENDPROC

   PROCEDURE GetDefaultValue(liIDProp) && Get default Value
      * liIDProp   - Property ID
      RETURN IIF(liIDProp=MyProperty,"",;
             IIF(liIDProp=MyProperty2,"",.NULL.)) && default return value
   ENDPROC

   PROCEDURE GetValueType(liIDProp) && Return the property type
      * liIDProp - Property ID
      RETURN IIF(liIDProp=MyProperty,_DBC_ValueType_String,;
             IIF(liIDProp=MyProperty2,_XXX_ValueType_XString,_DBC_ValueType_Unknown))
   ENDPROC


   PROCEDURE DBCValueToValue(liType,lcValue) && Convert DBC value to Value
      * liType  - Property type
      * luValue - Property value
      RETURN IIF(liType=_XXX_ValueType_XString,LEFT(lcValue,LEN(lcValue)-1),lcValue)
   ENDPROC


   PROCEDURE ValueToDBCValue(liType,luValue) && Convert value to DBC value
      * liType  - Property type
      * luValue - Property value
      RETURN IIF(liType=_XXX_ValueType_XString,luValue+CHR(0),.NULL.)
   ENDPROC


   PROCEDURE CheckValue() && Check Value
      LPARAMETERS liIDProp,liType,luValue
      * liIDProp   - Property ID
      * liType     - Value type
      * luValue    - Value

      * 1) check type
      * 2) check interval
      * 4) return .T. is value valid or .F. is invalid
      RETURN IIF(liIDProp=MyProperty,.T.,;
             IIF(liIDProp=MyProperty2,TYPE("luValue")="C" AND INLIST(luValue,"A","B","C"),.F.))
   ENDPROC


   PROCEDURE CheckProperties() && Check property value (DBC value)
      LPARAMETERS liIDProp,liType,lcValue
      * liIDProp   - Property ID
      * liType     - Value type
      * lcValue    - DBC value

      RETURN IIF(liIDProp=MyProperty2,.T.,;
             IIF(liIDProp=MyProperty2,RIGHT(lcValue,1)=CHR(0) AND INLIST(lcValue,"A"+CHR(0),"B"+CHR(0),"C"+CHR(0)),.F.))
   ENDPROC

ENDDEFINE
